/* Copyright (c) Compaq Computer Corporation, 1999 */

#include <linux/unistd.h>
#include <linux/itsy_session.h>

#define FB_DEBUG		0

#define FB_MINOR		128
#define FB_DISPLAY_MINOR	129
#define FB_CLONE_MINOR		130
#define FB_NONE_MINOR		131
#define FB_VC_MINOR		132
#define FB_SESSION_MINOR	133

#define FB_MIN  	 8
#define FB_MID		16
#define FB_MAX 		32
#define FB_VC		 0
#define FB_NONE		FB_MIN-1

#define EXECNAME_SIZE   64

#define FBWM_SIZE ((sizeof(struct fbwmStruct) + 4095) & ~0xfff)

struct fbData {
  struct fbData 	*next;		/* circular queue of fb with same pid */
  pid_t			pid;		/* process id of fb user	*/
  unsigned char 	*addr;		/* framebuffer virtual address	*/
  unsigned int		flags;
#define SCREEN_ORIENTATION_MASK	0x03	/* 0 for natural, 
					 * 1 rotate Itsy  90 deg clockwise,
					 * 2 rotate Itsy 180 deg clockwise,
					 * 3 rotate Itsy 270 def clockwise. */
#define INUSE_FLAG		0x04	/* framebuffer in use 		*/
#define ALLOC_FLAG		0x08	/* framebuffer space allocated  */
#define DO_FREE_FLAG		0x10	/* kfree framebuffer when done  */
#define VISIBLE_FLAG		0x20	/* visible fb for that process  */
  unsigned int		alloc_sid;
  unsigned int		mmap_count;
  unsigned int		open_count;
  char 			execname[ITSY_SESSION_NAME_LEN];
};

struct fbwmStruct {
  int			visibleFB;	/* framebuffer visible on LCD 	*/
  int			maxCnt;		/* FB_MAX */
  int			size;		/* of structure in bytes */
  struct fbData		fbArray[FB_MAX];
/*   char			eventBuffer[EVENT_BUFFER_SIZE]; */
/*   char			wmBuffer[WM_BUFFER_SIZE]; */
};
				    
