#include <linux/itsy_version.h>
/*
 * Copyright (c) Compaq Computer Corporation, 1999
 *
 * Author: Deborah A. Wallach
 */

/* 
 * note - we assume the GPDR has already been set by the monitor 
 * to reflect the uart chip control pins (23 and 24 or just 23)
 */
static __INLINE__ void itsy_turn_mb_uart_hardware_on(void)
{
  if (is_itsy_v1()) {
    outl(0x01800000, GPSR_V);   /* bits 23 and 24 = 1 */
  }
  else if (is_itsy_v2()) {
    outl(0x00800000, GPSR_V);   /* bit 23 = 1 */
  }
}
static __INLINE__ void itsy_turn_mb_uart_hardware_off(void)
{
  if (is_itsy_v1()) {
    outl(0x01800000, GPCR_V);   /* bits 23 and 24 = 0 */
  }
  else if (is_itsy_v2()) {
    outl(0x00800000, GPCR_V);   /* bit 23 = 0 */
  }
}
static __INLINE__ void itsy_setup_uart1(void)
{
  outl(1, SDCR0_V);   /* choose uart mode not sdlc mode */
}
static __INLINE__ void itsy_setup_uart1_alt(void)
{
  unsigned int tmp;
  /* set up for using alternate UART */    
  tmp = inl(GAFR_V);
  outl(tmp|0xc000, GAFR_V);   /* bits 15, 14 = 1,1 */
  tmp = inl(GPDR_V);
  outl(tmp|0x4000, GPDR_V);   /* bits 15, 14 = 0,1 */
  tmp = inl(PPAR_V);
  outl(tmp|0x1000, PPAR_V);   /* bit 12 = 1 */
}

