@  linux/arch/arm/drivers/scsi/acornscsi-io.S: Acorn SCSI card IO

@ Purpose: transfer a block of data from the acorn scsi card to memory
@ Proto  : void acornscsi_in(int portstrt, char *buffer, int length)
@ Returns: nothing

#include <asm/hardware.h>

#if (IO_BASE == (PCIO_BASE & 0xff000000))
#define ADDR(off,reg)						\
		tst	off, $0x80000000			;\
		mov	reg, $IO_BASE				;\
		orreq	reg, reg, $(PCIO_BASE & 0x00ff0000)
#else
#define ADDR(off,reg)						\
		tst	off, $0x80000000			;\
		movne	reg, $IO_BASE				;\
		moveq	reg, $(PCIO_BASE & 0xff000000)		;\
		orreq	reg, reg, $(PCIO_BASE & 0x00ff0000)
#endif

		.align
		.global	__acornscsi_in
__acornscsi_in:
		mov	ip, sp
		stmfd	sp!, {r4 - r10, fp, ip, lr, pc}
		sub	fp, ip, #4
		ADDR(r0,r3)
		add	r0, r3, r0, lsl #2
		mov	ip, #0xff
		orr	ip, ip, ip, lsl #8
acornscsi_in1lp:
		subs	r2, r2, #32
		bmi	acornscsi_in16
		ldmia	r0!, {r3, r4, r5, r6}
		and	r3, r3, ip
		orr	r3, r3, r4, lsl #16
		and 	r4, r5, ip
		orr	r4, r4, r6, lsl #16
		ldmia	r0!, {r7, r8, r9, r10}
		and	r5, r7, ip
		orr	r5, r5, r8, lsl #16
		and	r6, r9, ip
		orr	r6, r6, r10, lsl #16
		stmia	r1!, {r3 - r6}
		ldmia	r0!, {r3, r4, r5, r6}
		and	r3, r3, ip
		orr	r3, r3, r4, lsl #16
		and 	r4, r5, ip
		orr	r4, r4, r6, lsl #16
		ldmia	r0!, {r7, r8, r9, r10}
		and	r5, r7, ip
		orr	r5, r5, r8, lsl #16
		and	r6, r9, ip
		orr	r6, r6, r10, lsl #16
		stmia	r1!, {r3 - r6}
		bne	acornscsi_in1lp
		ldmea	fp, {r4 - r10, fp, sp, pc}^
acornscsi_in16:	adds	r2, r2, #16
		bmi	acornscsi_in8
acornscsi_in16lp:
		ldmia	r0!, {r3, r4, r5, r6}
		and	r3, r3, ip
		orr	r3, r3, r4, lsl #16
		and 	r4, r5, ip
		orr	r4, r4, r6, lsl #16
		ldmia	r0!, {r7, r8, r9, r10}
		and	r5, r7, ip
		orr	r5, r5, r8, lsl #16
		and	r6, r9, ip
		orr	r6, r6, r10, lsl #16
		stmia	r1!, {r3 - r6}
		ldmeqea	fp, {r4 - r10, fp, sp, pc}^
		sub	r2, r2, #16
acornscsi_in8:	adds	r2, r2, #8
		bmi	acornscsi_in4
		ldmia	r0!, {r3, r4, r5, r6}
		and	r3, r3, ip
		orr	r3, r3, r4, lsl #16
		and	r4, r5, ip
		orr	r4, r4, r6, lsl #16
		stmia	r1!, {r3 - r4}
		ldmeqea	fp, {r4 - r10, fp, sp, pc}^
		sub	r2, r2, #8
acornscsi_in4:	adds	r2, r2, #4
		bmi	acornscsi_in2
		ldmia	r0!, {r3, r4}
		and	r3, r3, ip
		orr	r3, r3, r4, lsl #16
		str	r3, [r1], #4
		ldmeqea	fp, {r4 - r10, fp, sp, pc}^
		sub	r2, r2, #4
acornscsi_in2:	adds	r2, r2, #2
		ldr	r3, [r0], #4
		and	r3, r3, ip
		strb	r3, [r1], #1
		mov	r3, r3, lsr #8
		strplb	r3, [r1], #1
		ldmea	fp, {r4 - r10, fp, sp, pc}^

@ Purpose: transfer a block of data from memory to the acorn scsi card
@ Proto  : void acornscsi_in(int portstrt, char *buffer, int length)
@ Returns: nothing

		.global	__acornscsi_out
__acornscsi_out:
		mov	ip, sp
		stmfd	sp!, {r4 - r10, fp, ip, lr, pc}
		sub	fp, ip, #4
		ADDR(r0,r3)
		add	r0, r3, r0, lsl #2
		mov	ip, #0xff
		orr	ip, ip, ip, lsl #8
acornscsi_out1lp:
		subs	r2, r2, #32
		bmi	acornscsi_out16
		ldmia	r1!, {r7 - r10}
		mov	r3, r7, lsl #16
		orr	r3, r3, r3, lsr #16
		mov	r4, r7, lsr #16
		orr	r4, r4, r4, lsl #16
		mov	r5, r8, lsl #16
		orr	r5, r5, r5, lsr #16
		mov	r6, r8, lsr #16
		orr	r6, r6, r6, lsl #16
		stmia	r0!, {r3, r4, r5, r6}
		mov	r7, r9, lsl #16
		orr	r7, r7, r7, lsr #16
		mov	r8, r9, lsr #16
		orr	r8, r8, r8, lsl #16
		mov	r9, r10, lsl #16
		orr	r9, r9, r9, lsr #16
		mov	r10, r10, lsr #16
		orr	r10, r10, r10, lsl #16
		stmia	r0!, {r7, r8, r9, r10}
		ldmia	r1!, {r7 - r10}
		mov	r3, r7, lsl #16
		orr	r3, r3, r3, lsr #16
		mov	r4, r7, lsr #16
		orr	r4, r4, r4, lsl #16
		mov	r5, r8, lsl #16
		orr	r5, r5, r5, lsr #16
		mov	r6, r8, lsr #16
		orr	r6, r6, r6, lsl #16
		stmia	r0!, {r3, r4, r5, r6}
		mov	r7, r9, lsl #16
		orr	r7, r7, r7, lsr #16
		mov	r8, r9, lsr #16
		orr	r8, r8, r8, lsl #16
		mov	r9, r10, lsl #16
		orr	r9, r9, r9, lsr #16
		mov	r10, r10, lsr #16
		orr	r10, r10, r10, lsl #16
		stmia	r0!, {r7, r8, r9, r10}
		bne	acornscsi_out1lp
		ldmea	fp, {r4 - r10, fp, sp, pc}^
acornscsi_out16:
		adds	r2, r2, #16
		bmi	acornscsi_out8
acornscsi_out16lp:
		ldmia	r1!, {r7 - r10}
		mov	r3, r7, lsl #16
		orr	r3, r3, r3, lsr #16
		mov	r4, r7, lsr #16
		orr	r4, r4, r4, lsl #16
		mov	r5, r8, lsl #16
		orr	r5, r5, r5, lsr #16
		mov	r6, r8, lsr #16
		orr	r6, r6, r6, lsl #16
		stmia	r0!, {r3, r4, r5, r6}
		mov	r7, r9, lsl #16
		orr	r7, r7, r7, lsr #16
		mov	r8, r9, lsr #16
		orr	r8, r8, r8, lsl #16
		mov	r9, r10, lsl #16
		orr	r9, r9, r9, lsr #16
		mov	r10, r10, lsr #16
		orr	r10, r10, r10, lsl #16
		stmia	r0!, {r7, r8, r9, r10}
		ldmeqea	fp, {r4 - r10, fp, sp, pc}^
		sub	r2, r2, #16
acornscsi_out8:	adds	r2, r2, #8
		bmi	acornscsi_out4
		ldmia	r1!, {r5 - r6}
		mov	r3, r5, lsl #16
		orr	r3, r3, r3, lsr #16
		mov	r4, r5, lsr #16
		orr	r4, r4, r4, lsl #16
		mov	r5, r6, lsl #16
		orr	r5, r5, r5, lsr #16
		mov	r6, r6, lsr #16
		orr	r6, r6, r6, lsl #16
		stmia	r0!, {r3, r4, r5, r6}
		ldmeqea	fp, {r4 - r10, fp, sp, pc}^
		sub	r2, r2, #8
acornscsi_out4:	adds	r2, r2, #4
		bmi	acornscsi_out2
		ldr	r4, [r1], #4
		mov	r3, r4, lsl #16
		orr	r3, r3, r3, lsr #16
		mov	r4, r4, lsr #16
		orr	r4, r4, r4, lsl #16
		stmia	r0!, {r3, r4}
		ldmeqea	fp, {r4 - r10, fp, sp, pc}^
		sub	r2, r2, #4
acornscsi_out2:	adds	r2, r2, #2
		ldr	r3, [r1], #2
		and	r3, r3, ip
		strb	r3, [r0], #1
		mov	r3, r3, lsr #8
		strplb	r3, [r0], #1
		ldmea	fp, {r4 - r10, fp, sp, pc}^

