#include <stdio.h>
#include "list.h"
/* Copyright (c) Compaq Computer Corporation, 1999 */

struct test_data
{
    list_node_t node;
    char data[15];
};

void inline print_size(list_header_t *header);

int
main (void)
{
    list_header_t header;
    list_error_t   error;
    list_node_t   *node1;
    list_node_t   *node2;
    struct test_data data1;
    struct test_data data2;
    struct test_data data3;
    struct test_data data4;
    struct test_data data5;
    struct test_data data6;
    struct test_data data7;
    struct test_data data8;
    struct test_data data9;

    struct test_data *data; 
    int i;
    
        
    /* Declare some data to store in the lists */
    strcpy(data1.data, "Data Item 1");
    strcpy(data2.data, "Data Item 2");
    strcpy(data3.data, "Data Item 3");
    strcpy(data4.data, "Data Item 4");
    strcpy(data5.data, "Data Item 5");
    strcpy(data6.data, "Data Item 6");
    strcpy(data7.data, "Data Item 7");
    strcpy(data8.data, "Data Item 8");
    strcpy(data9.data, "Data Item 9");

    /* Test the Header creation and manipulation routines */
    printf ("\nTEST START list_header_init\n");

    if (error = list_header_init(&header))
    {
	printf ("BUG : list_header_init error %d\n", error);
    }

    printf ("\nInitialised the list\n");
    
    if (error = list_add_first(&header, (list_node_t *) &data1))
    {
	printf("BUG : list_add_first error %d\n", error);
    }
     
    print_size(&header);

    data = (struct test_data *) list_get_last(&header);
    if (data)
    {
	printf("data = %s\n", data->data);
    }
    
    print_size(&header);
 
    if (error = list_add_last(&header, (list_node_t *) &data2))
    {
	printf("BUG : list_add_last error %d\n", error);
    }
 
    print_size(&header);

    data = (struct test_data *) list_get_last(&header);
    if (data)
    {
	printf("data = %s\n", data->data);
    }

    print_size(&header);

    data = (struct test_data *) list_return_last(&header);
    if (data)
    {
	printf("data = %s\n", data->data);
    }

    print_size(&header);

    /* now add all the items to the list */

    if (error = list_add_last(&header, (list_node_t *) &data2))
    {
	printf("BUG : list_add_last error %d\n", error);
    }
    print_size(&header);

    if (error = list_add_last(&header, (list_node_t *) &data3))
    {
	printf("BUG : list_add_last error %d\n", error);
    }
    print_size(&header);
data = (struct test_data *) list_return_first(&header);
	if (data)
	{
	    printf("XXXX data = %s\n", data->data);
	}
    if (error = list_add_last(&header, (list_node_t *) &data4))
    {
	printf("BUG : list_add_last error %d\n", error);
    }
    print_size(&header);

    if (error = list_add_last(&header, (list_node_t *) &data5))
    {
	printf("BUG : list_add_last error %d\n", error);
    } 
    print_size(&header);
data = (struct test_data *) list_return_first(&header);
	if (data)
	{
	    printf("XXXX data = %s\n", data->data);
	}
    if (error = list_add_last(&header, (list_node_t *) &data6))
    {
	printf("BUG : list_add_last error %d\n", error);
    } 
    print_size(&header);

    if (error = list_add_last(&header, (list_node_t *) &data7))
    {
	printf("BUG : list_add_last error %d\n", error);
    }
    print_size(&header);

    /* 
     * now look at them all. 
     */
#if 0
    data = (struct test_data *) list_get_first(&header);
    if (data)
    {
	printf("data = %s\n", data->data);
    }
    print_size(&header);

    for (i=0; i<8; i++)
    {
	data = (struct test_data *) list_get_next((list_node_t *) data);
	if (data)
	{
	    printf("data = %s\n", data->data);
	}
	print_size(&header);
    }
#endif 
    for (i=0; i<8; i++)
    {
	data = (struct test_data *) list_return_first(&header);
	if (data)
	{
	    printf("data = %s\n", data->data);
	}
	print_size(&header);
    }
    return 0;
}

void inline
print_size(list_header_t *header)
{
    printf("%d nodes left on the list\n", list_header_getCount(header));
}
