/*
 * include/asm-arm/arch-brutus/irq.h
 *
 * Copyright (C) 1996 Russell King
 * Updates for SA1100/Brutus are:
 *  Copyright (c) Compaq Computer Corporation, 1998
 *
 *  Author: Deborah A. Wallach
 */

#include "io_reg.h"

#define BUILD_IRQ(s,n,m)

extern void IRQ_interrupt(void);
extern void timer_IRQ_interrupt(void);
extern void fast_IRQ_interrupt(void);
extern void bad_IRQ_interrupt(void);
extern void probe_IRQ_interrupt(void);

#define IRQ_interrupt0 timer_IRQ_interrupt /* IRQ_MAINPB */
#define IRQ_interrupt1 IRQ_interrupt
#define IRQ_interrupt2 IRQ_interrupt
#define IRQ_interrupt3 IRQ_interrupt
#define IRQ_interrupt4 IRQ_interrupt
#define IRQ_interrupt5 IRQ_interrupt
#define IRQ_interrupt6 IRQ_interrupt
#define IRQ_interrupt7 IRQ_interrupt
#define IRQ_interrupt8 IRQ_interrupt
#define IRQ_interrupt9 IRQ_interrupt
#define IRQ_interrupt10 IRQ_interrupt
#define IRQ_interrupt11 IRQ_interrupt
#define IRQ_interrupt12 IRQ_interrupt
#define IRQ_interrupt13 IRQ_interrupt
#define IRQ_interrupt14 IRQ_interrupt
#define IRQ_interrupt15 IRQ_interrupt
#define IRQ_interrupt16 IRQ_interrupt
#define IRQ_interrupt17 IRQ_interrupt
#define IRQ_interrupt18 IRQ_interrupt
#define IRQ_interrupt19 IRQ_interrupt
#define IRQ_interrupt20 IRQ_interrupt
#define IRQ_interrupt21 IRQ_interrupt
#define IRQ_interrupt22 IRQ_interrupt
#define IRQ_interrupt23 IRQ_interrupt
#define IRQ_interrupt24 IRQ_interrupt
#define IRQ_interrupt25 IRQ_interrupt
#define IRQ_interrupt26 timer_IRQ_interrupt /* IRQ_OST0 */
#define IRQ_interrupt27 timer_IRQ_interrupt /* IRQ_OST1 */
#define IRQ_interrupt28 IRQ_interrupt
#define IRQ_interrupt29 IRQ_interrupt
#define IRQ_interrupt30 IRQ_interrupt
#define IRQ_interrupt31 IRQ_interrupt

#define IRQ_INTERRUPT(n)	IRQ_interrupt##n
#define FAST_INTERRUPT(n)	fast_IRQ_interrupt
#define BAD_INTERRUPT(n)	bad_IRQ_interrupt
#define PROBE_INTERRUPT(n)	probe_IRQ_interrupt

static __inline__ void mask_irq(unsigned int irq)
{
  *IRQ_ICMR_V &= ~((unsigned long)(1 << irq));
}

static __inline__ void unmask_irq(unsigned int irq)
{
  *IRQ_ICMR_V |= ((unsigned long)(1 << irq));
}
 
static __inline__ void mask_irqs(unsigned long mask)
{
  *IRQ_ICMR_V &= ~(mask);
}

static __inline__ void unmask_irqs(unsigned long mask)
{
  *IRQ_ICMR_V |= mask;
}

static __inline__ unsigned long get_enabled_irqs(void)
{
  return(*IRQ_ICMR_V);
}

static __inline__ int is_enabled_irq(unsigned int irq)
{
  return(*IRQ_ICMR_V | ((unsigned long)(1 << irq)));
}

static __inline__ void irq_init_irq(void)
{
  unsigned long flags;

  save_flags(flags);
  cli();
  *IRQ_ICMR_V = 0;	/* clear  all interrupt enables */
  *IRQ_ICLR_V = 0;	/* vector all interrupts to IRQs (vs. FIQs) */
  *IRQ_ICCR_V = 1;	/* only unmasked interrupts cause exit from idle mode */
  restore_flags(flags);
}
