
/*
 *	FILE    	error.h
 *
 *	Version 	2.0
 *	Author  	Marc A. Viredaz
 *	        	Compaq Western Research Laboratory, Palo Alto, CA
 *	        	(DEC Western Research Laboratory, Palo Alto, CA)
 *	Date    	January 2000 (March 1998)
 *	System  	Itsy versions 1.0/1.1, 1.5, 1.6, 1.7, and 2.0/2.1
 *	        	(StrongARM SA-1100)
 *	Language	C
 *	Purpose 	Error handler for the Itsy computer's monitor.
 *	Copyright	(c) Compaq Computer Corporation, 1998, 2000.
 */


#ifndef LANGUAGE
#define LANGUAGE	C
#endif /* !defined (LANGUAGE) */

#ifdef __linux__
#include <asm/arch/ARMv4.h>
#else
#include <ARMv4.h>
#endif /* __linux__ */

#define C       	0
#define Assembly	1


/*
 * ERROR STATUSES
 */

#define Success 	0
#define Failure 	1
#define InvalStatErr	2
#define StMemBnkNbErr	3
#define ClkFreqNbErr	4
#define CIDRdErr	5
#define UnkwnCIDErr	6
#define UnkwnRevErr	7
#define CIDVerErr	8
#define CIDBnkErr	9
#define UnkwnClkFreqErr	10
#define NonVolIdErr	11
#define NonVolIdVerErr	12
#define UARTNbErr	13
#define UARTInitErr	14
#define UARTUseErr	15
#define UARTPinUseErr	16
#define UARTUnInitErr	17
#define UARTParErr	18
#define UARTFrmErr	19
#define UARTRcOvrFlErr	20
#define BaseErr 	21
#define NbDigitErr	22
#define FlStMemBnkErr	23
#define FlInDevErr	24
#define FlStMemIntfErr	25
#define FlUnkwnMnf16Err	26
#define FlUnkwnMnf32Err	27
#define FlUnkwnDev16Err	28
#define FlUnkwnDev32Err	29
#define FlIncSubBnkErr	30
#define FlSizeErr	31
#define FlSctErs2x8Err	32
#define FlSctErs4x8Err	33
#define FlSctErs1x16Err	34
#define FlSctErs2x16Err	35
#define FlPrgm2x8Err	36
#define FlPrgm4x8Err	37
#define FlPrgm1x16Err	38
#define FlPrgm2x16Err	39
#define FlPgPrgm2x8Err	40
#define FlPgPrgm4x8Err	41
#define FlPgPrgm1x16Err	42
#define FlPgPrgm2x16Err	43
#define FlChk8Err	44
#define FlChk16Err	45
#define FlChk32Err	46


/*
 * GLOBAL VARIABLES
 */

#if LANGUAGE == C
extern unsigned int	ErrStatus ;
extern Address  	ErrAddress ;
extern Word     	ErrData ;
#elif LANGUAGE == Assembly
	IMPORT	ErrStatus
	IMPORT	ErrAddress
	IMPORT	ErrData
#endif /* LANGUAGE == C || LANGUAGE == Assembly */


#undef C
#undef Assembly
