/*
 * sa1100 os timers
 *
 * Copyright (c) Compaq Computer Corporation, 1998
 *
 * Author: Lawrence S. Brakmo
 *
 * For keeping track of who is using which sa1100 os timers.
 *
 * Changelog:
 * 22-01-1998	lsb	Created 
 *
 */

#ifndef ostimers_h
#define ostimers_h

#include <asm/arch/io_reg.h>

#define TIMER1_RATE (3686400)

/*
 * OS timer 0 used in time.h
 */

/*
 * OS timer 1 used in keyb_brutus.c to read keyboard, touchscreen and
 * to flash the cursor
 */

extern __inline__ int reset_timer1 (unsigned long delay)
{
  unsigned long next_os_timer_match;
  
  next_os_timer_match = inl(OSCR_V) + delay;
  outl(next_os_timer_match, OSMR1_V);
  outl(0x2, OSSR_V);

  return (1);
}

extern __inline__ void clear_timer1 (void)
{
  outl(0x2, OSSR_V);
}

extern __inline__ void setup_timer1 (unsigned long delay)
{
  unsigned long next_os_timer_match, i;

  next_os_timer_match = inl(OSCR_V) + delay;
  outl(next_os_timer_match, OSMR1_V);
  outl(0x2, OSSR_V);
  i = inl(OIER_V);
  i |= 2;
  outl(i, OIER_V);
}

extern __inline__ void cleanup_timer1 (void)
{
  int i;

  i = inl(OIER_V);
  i &= ~0x2;
  outl(i, OIER_V);
  outl(0x2, OSSR_V);
}

#endif
