/*
 * linux/include/asm-arm/arch-brutus/system.h
 *
 * Copyright (c) 1996 Russell King
 * Updates for SA1100/Brutus are:
 *  Copyright (c) Compaq Computer Corporation, 1998
 *
 *  Author: Deborah A. Wallach
 */
#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H

#include <asm/proc-fns.h>

/* 'halts' the itsy (drops it to the monitor via jump 0) */
#define arch_hard_halt() {						\
	extern void ecard_reset (int card);				\
	ecard_reset (-1);						\
	cli();								\
	__asm__ __volatile__("msr  spsr, r1;"				\
			     "mcr  p15, 0, %0, c1, c0, 0;"		\
			     "movs pc, #0"				\
			 : 						\
			 : "r" (processor.u.armv3v4.reset()));		\
	}

#endif

/* 'resets' the itsy (drops it to the monitor via software reset) */
#define arch_hard_reset() {						\
	extern void ecard_reset (int card);				\
	ecard_reset (-1);						\
	cli();								\
	__asm__ __volatile__("msr  spsr, r1;"				\
			     "mov  r0, %0;"               		\
			     "ldr  r4, =0xe8030000;" /* RSRR_V */       \
			     "mov  r5, #1;"                             \
			     "str  r5, [r4];"				\
			 : 						\
			 : "r" (processor.u.armv3v4.reset()));		\
	}


