/*
 * linux/include/asm-arm/arch-brutus/time.h
 *
 * Copyright (c) Compaq Computer Corporation, 1998
 *
 * Author: Deborah A. Wallach
 *
 */

static volatile int next_os_timer_match = 0;

extern __inline__ unsigned long gettimeoffset (void)
{
	unsigned long offset = 0;
	unsigned int count;
	unsigned long nmatch;

	nmatch = next_os_timer_match;
	count = inl(OSCR_V);

	count = count - (nmatch - LATCH);
	/*
	 * count = number of clock ticks since last interrupt
	 */
	offset += count * tick / LATCH;
	return offset;
}

/*
 * Reset the timer every time to get centisecond interrutps (why?)
 */
extern __inline__ int reset_timer (void)
{
  next_os_timer_match = LATCH + inl(OSCR_V);
  outl(next_os_timer_match, OSMR0_V);
  outl(0x1, OSSR_V);  /* clear match on timer 0 */
  return(1);
}

extern __inline__ unsigned long setup_timer (void)
{
  outl(0, OSCR_V);    /* initialize free-running timer register */
  outl(0, OSMR0_V);   /* set up match register */
  outl(0xf, OSSR_V);  /* clear status on all timers */
  outl(1, OIER_V);    /* enable match on timer 0 to cause interrupts */
  reset_timer();

	/*
	 * Default the date to 1 Jan 1970 0:0:0
	 * You will have to run a time daemon to set the
	 * clock correctly at bootup
	 */
	return mktime(1970, 1, 1, 0, 0, 0);
}
