/*
 * linux/include/asm-arm/arch-rpc/mmu.h
 *
 * Copyright (c) 1996 Russell King.
 *
 * Changelog:
 *  20-10-1996	RMK	Created
 */
#ifndef __ASM_ARCH_MMU_H
#define __ASM_ARCH_MMU_H

#define NR_BANKS 5

struct dram_bank {
	unsigned int virt_offset;
	int v2p_offset;
};

extern struct dram_bank drambank[NR_BANKS];

extern __inline__ unsigned long virt_to_phys(unsigned long vpage)
{
	unsigned int bank = 0;

	while (vpage >= drambank[bank].virt_offset && bank < NR_BANKS)
		bank ++;

	return vpage - drambank[bank].v2p_offset;
}

extern __inline__ unsigned long phys_to_virt(unsigned long ppage)
{
	unsigned int bank;

	if (ppage > 0x10000000)
		bank = (ppage >> 26) & 3;
	else
		bank = 5;
	return ppage + drambank[bank].v2p_offset;
}

#endif
