/*
 * linux/include/asm-arm/floppy.h
 *
 * (C) 1996 Russell King
 */
#ifndef __ASM_ARM_FLOPPY_H
#define __ASM_ARM_FLOPPY_H
#if 0
#include <asm/arch/floppy.h>
#endif

#define fd_outb(val,port)	outb((val),(port))
#define fd_inb(port)		inb((port))
#define fd_request_irq()	request_irq(IRQ_FLOPPYDISK,floppy_interrupt,\
					SA_INTERRUPT|SA_SAMPLE_RANDOM,"floppy",NULL)
#define fd_free_irq()		free_irq(IRQ_FLOPPYDISK,NULL)
#define fd_disable_irq()	disable_irq(IRQ_FLOPPYDISK)
#define fd_enable_irq()		enable_irq(IRQ_FLOPPYDISK)

#define fd_request_dma()	request_dma(FLOPPY_DMA,"floppy")
#define fd_free_dma()		free_dma(FLOPPY_DMA)
#define fd_disable_dma()	disable_dma(FLOPPY_DMA)
#define fd_enable_dma()		enable_dma(FLOPPY_DMA)
#define fd_clear_dma_ff()	clear_dma_ff(FLOPPY_DMA)
#define fd_set_dma_mode(mode)	set_dma_mode(FLOPPY_DMA, (mode))
#define fd_set_dma_addr(addr)	set_dma_addr(FLOPPY_DMA, (addr))
#define fd_set_dma_count(len)	set_dma_count(FLOPPY_DMA, (len))
#define fd_cacheflush(addr,sz)

extern unsigned char floppy_selects[2][4];

#define fd_setdor(dor)										\
{												\
	int new_dor = (dor);									\
	if (new_dor & 0xf0)									\
		fd_outb((new_dor & 0x0c) | floppy_selects[fdc][new_dor & 3], FD_DOR);		\
	else											\
		fd_outb((new_dor & 0x0c), FD_DOR);						\
}

extern __inline__ void fd_scandrives (void)
{
#if 0
	int floppy, drive_count;

	fd_disable_irq();
	raw_cmd = &default_raw_cmd;
	raw_cmd->flags = FD_RAW_SPIN | FD_RAW_NEED_SEEK;
	raw_cmd->track = 0;
	raw_cmd->rate = ?;
	drive_count = 0;
	for (floppy = 0; floppy < 4; floppy ++) {
		current_drive = drive_count;
		/*
		 * Turn on floppy motor
		 */
		if (start_motor(redo_fd_request))
			continue;
		/*
		 * Set up FDC
		 */
		fdc_specify();
		/*
		 * Tell FDC to recalibrate
		 */
		output_byte(FD_RECALIBRATE);
		LAST_OUT(UNIT(floppy));
		/* wait for command to complete */
		if (!successful) {
			int i;
			for (i = drive_count; i < 3; i--)
				floppy_selects[fdc][i] = floppy_selects[fdc][i + 1];
			floppy_selects[fdc][3] = 0;
			floppy -= 1;
		} else
			drive_count++;
	}
#else
	floppy_selects[0][0] = 0x10;
	floppy_selects[0][1] = 0x21;
	floppy_selects[0][2] = 0x23;
	floppy_selects[0][3] = 0x33;
#endif
}
	
#endif
