/* asm/proc/unaligned.h */
/* Added by SanM for ARM misaligned access trap handler, and proc utils */

#ifndef ASM_PROC_UNALIGNED_H
#define ASM_PROC_UNALIGNED_H

asmlinkage int do_alignfixup(unsigned long addr,int fsr,int error_code,struct pt_regs *regs);

void do_glap(char *glap_msg,struct pt_regs *regs);
void misalign_init(void);

#define IMMED_BIT(inst) \
    (!(inst & 0x2000000))
#define PREINDEX_BIT(inst) \
    (inst & 0x1000000)
#define ADDOFFSET_BIT(inst) \
    (inst & 0x800000)
#define BASEUPDATE_BIT(inst) \
    (inst & 0x200000)
#define LOAD_BIT(inst) \
    (inst & 0x100000)

#define RN_BITS(inst) \
    (((inst & 0xf0000)>>16))
#define RD_BITS(inst) \
    (((inst & 0xf000)>>12))
#define CODING_BITS(inst) \
    (((inst & 0xe000000)>>25))
#define RM_BITS(inst) \
    (inst & 0xf)
#define IS_SHIFT(inst) \
    (((inst & 0xff0)>>4))
#define SHIFT_BITS(inst) \
    (((inst & 0xf80)>>7))
#define SHIFT_TYPE(inst) \
    (((inst & 0x60)>>5))
#define OFFSET_BITS(inst) \
    ((inst & 0xfff))
#define SHIFT_LSL 0
#define SHIFT_LSR 1
#define SHIFT_ASR 2
#define SHIFT_RORRRX 3

typedef struct stats_misaligned
  {
  unsigned int UI_sys;
  unsigned int UI_user;
  unsigned int UI_word;
  unsigned int UI_short;
  unsigned int UI_multiple;
  unsigned int UI_swap;
  unsigned int UI_unsupported;
  } STATS_MISALIGNED;
#endif
