/*
 * include/asm-arm/processor.h
 *
 * Copyright (C) 1995 Russell King
 */

#ifndef __ASM_ARM_PROCESSOR_H
#define __ASM_ARM_PROCESSOR_H

#define DECLARE_THREAD_STRUCT							\
struct thread_struct {								\
	unsigned long	fs;			/* simulated fs		*/	\
	unsigned long	address;		/* Address of fault	*/	\
	unsigned long	trap_no;		/* Trap number		*/	\
	unsigned long	error_code;		/* Error code of trap	*/	\
	unsigned long	fpe_save[140/4];	/* FPE save state	*/	\
	EXTRA_THREAD_STRUCT							\
}

#include <asm/arch/processor.h>
#include <asm/proc/processor.h>

#define INIT_TSS  {			\
	0,				\
	0,				\
	0,				\
	0,				\
	{ 0, },				\
	EXTRA_THREAD_STRUCT_INIT	\
}

#endif /* __ASM_ARM_PROCESSOR_H */
