/*
 * buttons.h
 * Copyright (c) Compaq Computer Corporation, 1998, 1999
 *
 * Author: Larry Brakmo and Carl Waldspurger
 *
 * The buttons device is a character device with major number of 44 and
 * minor number of 3.
 *
 * A read to this device will return a long with the current button state.
 *
 * BUTTON_ST	Side top (farther from screen) button
 * BUTTON_SB	Side bottom (closest to screen) button
 * BUTTON_FT	Front top round button
 * BUTTON_FB	Front bottom round button
 * BUTTON_R	Front rectangular button
 *
 */

#ifndef buttons_h
#define buttons_h

/* button names */
#define	BUTTON_SIDE_TOP		(0x001)
#define	BUTTON_SIDE_BOTTOM	(0x002)
#define	BUTTON_FRONT_BOTTOM	(0x040)
#define	BUTTON_FRONT_TOP	(0x080)
#define	BUTTON_RECTANGLE	(0x100)

/* cursor buttons */
#define	BUTTON_CURSOR_UP	(0x004)
#define	BUTTON_CURSOR_DOWN	(0x008)
#define	BUTTON_CURSOR_LEFT	(0x010)
#define BUTTON_CURSOR_RIGHT	(0x020)
#define BUTTON_CURSOR_VERTICAL	(BUTTON_CURSOR_UP    | BUTTON_CURSOR_DOWN)
#define	BUTTON_CURSOR_HORIZ	(BUTTON_CURSOR_LEFT  | BUTTON_CURSOR_RIGHT)
#define	BUTTON_CURSOR_ANY	(BUTTON_CURSOR_HORIZ | BUTTON_CURSOR_VERTICAL)

/* encoder directions */
#define	BUTTON_ENCODER_A	(0x200)
#define	BUTTON_ENCODER_B	(0x400)

/* obsolete names */
#define BUTTON_ST		BUTTON_SIDE_TOP
#define BUTTON_SB		BUTTON_SIDE_BOTTOM
#define BUTTON_FT		BUTTON_FRONT_TOP
#define BUTTON_FB		BUTTON_FRONT_BOTTOM
#define BUTTON_R		BUTTON_RECTANGLE

#endif	/* buttons_h */
