/*
 * Itsy Buttons Interface
 * Copyright (c) Compaq Computer Corporation, 1999
 *
 * Author: Carl Waldspurger
 *
 * $Log: itsy_buttons.h,v $
 * Revision 2.3  1999/12/23  01:28:24  kerr
 * Updated Copyright information for entire source tree.
 *
 * Revision 2.2  1999/05/12  18:01:09  caw
 * Included changes from itsy_sessions branch.
 *
 * Revision 2.1.2.1  1999/04/19  23:15:34  caw
 * Defined ioctls for initial button grab/ungrab support.
 *
 * Revision 2.1  1999/03/29  19:57:58  caw
 * Initial revision (still experimental).
 *
 */

#ifndef	ITSY_BUTTONS_H
#define	ITSY_BUTTONS_H

/*
 * includes
 *
 */

#include <linux/itsy_event.h>

/*
 * constants
 *
 */

#define	ITSY_EVENT_BUTTONS_STATE	(1)

/*
 * types
 *
 */

typedef struct {
  itsy_event_header common;
  int sid;
  ushort state;
} itsy_buttons_event;

/*
 * ioctl interface
 *
 */

/* driver ioctl type */
#define	BUTTONS_IOCTL_TYPE	'b'
#define	BUTTONS_IOCTL_MAXNR	(2)

/* ioctl commands */
#define	BUTTONS_GET_GRAB_ALL	_IOR(BUTTONS_IOCTL_TYPE, 0, ushort)
#define	BUTTONS_GET_GRAB	_IOR(BUTTONS_IOCTL_TYPE, 1, ushort)
#define	BUTTONS_SET_GRAB	_IO(BUTTONS_IOCTL_TYPE,  2)

#endif	/* ITSY_BUTTONS_H */
