/*
 * Itsy Event Definitions
 * Copyright (c) Compaq Computer Corporation, 1999
 *
 * Author: Carl Waldspurger and Lawrence Brakmo
 *
 * $Log: itsy_event.h,v $
 * Revision 2.7  1999/12/23  01:28:25  kerr
 * Updated Copyright information for entire source tree.
 *
 * Revision 2.6  1999/09/10  21:41:45  caw
 * Updated itsy_event_header field names to avoid conflicts with C++.
 *
 * Revision 2.5  1999/06/10  00:31:14  caw
 * Defined ITSY_EVENT_FLAG_USER flag.
 *
 * Revision 2.4  1999/05/12 18:01:10  caw
 * Included changes from itsy_sessions branch.
 *
 * Revision 2.3.2.1  1999/04/19  18:54:52  caw
 * Defined ITSY_EVENT_FLAG_NONE.
 *
 * Revision 2.3  1999/04/13  19:42:56  brakmo
 * Added a flag, foreground session id and register respectively.
 *
 * Revision 2.2  1999/02/03  00:11:32  caw
 * Removed includes, changed "u8" => "unsigned char".
 *
 * Revision 2.1  1999/02/02  01:08:18  caw
 * Initial revision.
 *
 */

#ifndef	ITSY_EVENT_H
#define	ITSY_EVENT_H

/*
 * constants
 *
 */

/* event classes */
#define	ITSY_EVENT_CLASS_SESSION	(1)
#define	ITSY_EVENT_CLASS_DISPLAY	(2)
#define	ITSY_EVENT_CLASS_TOUCHSCREEN	(3)
#define	ITSY_EVENT_CLASS_BUTTONS	(4)
#define	ITSY_EVENT_CLASS_ADC		(5)

/* event flags (bitmask) */
#define	ITSY_EVENT_FLAG_NONE		(0x00)
#define	ITSY_EVENT_FLAG_SYNTHETIC	(0x01)
#define ITSY_EVENT_FLAG_GRABBED		(0x02)
#define	ITSY_EVENT_FLAG_SUSER		(0x04)

/*
 * types
 *
 */

typedef struct {
  struct timeval timestamp;
  unsigned char  event_class;
  unsigned char  event_type;
  unsigned char  size;
  unsigned char  flags;
} itsy_event_header;

#endif	/* ITSY_EVENT_H */
