/*
 * Itsy Powerbutton Interface
 * Copyright (c) Compaq Computer Corporation, 1999
 *
 * Author: Carl Waldspurger
 *
 * $Log: itsy_powerbutton.h,v $
 * Revision 2.4  2000/01/19  00:09:06  brakmo
 * Incremented POWERBUTTON_IOCTL_MAXNR by 1 to account for deep sleep ioctl.
 *
 * Revision 2.3  2000/01/11 22:35:41  kerr
 * Support for deep sleep mode.
 *
 * Revision 2.2  1999/12/23  01:28:27  kerr
 * Updated Copyright information for entire source tree.
 *
 * Revision 2.1  1999/05/12  18:01:10  caw
 * Included changes from itsy_sessions branch.
 *
 * Revision 1.1.2.3  1999/04/23  20:47:44  caw
 * Defined POWERBUTTON_ENTER_SLEEP_MODE ioctl.
 *
 * Revision 1.1.2.2  1999/04/23  20:05:26  caw
 * Defined BUTTON_POWER constant (no conflicts with "buttons.h").
 *
 * Revision 1.1.2.1  1999/04/20  17:13:01  caw
 * Initial revision.
 *
 */

#ifndef	ITSY_POWERBUTTON_H
#define	ITSY_POWERBUTTON_H

/*
 * includes
 *
 */

#include <linux/itsy_event.h>
#include <linux/itsy_buttons.h>

/*
 * constants
 *
 */

#define	BUTTON_POWER		(0x200)
 

/*
 * ioctl interface
 *
 */

/* driver ioctl type */
#define	POWERBUTTON_IOCTL_TYPE		'p'
#define	POWERBUTTON_IOCTL_MAXNR		(4)

/* ioctl commands */
#define	POWERBUTTON_GET_SLEEP_ALL	_IOR(POWERBUTTON_IOCTL_TYPE, 0, int)
#define	POWERBUTTON_GET_SLEEP		_IOR(POWERBUTTON_IOCTL_TYPE, 1, int)
#define	POWERBUTTON_SET_SLEEP		_IO(POWERBUTTON_IOCTL_TYPE,  2)
#define	POWERBUTTON_ENTER_SLEEP_MODE	_IO(POWERBUTTON_IOCTL_TYPE,  3)
#define	POWERBUTTON_ENTER_DEEP_SLEEP_MODE	_IO(POWERBUTTON_IOCTL_TYPE,  4)

#endif	/* ITSY_POWERBUTTON_H */
